
; Alles was mit dem Sortieren/Arrays zu tun hat

; MaxIndex von 2 Werten (sollte man inlinen)
Func _2MaxI(ByRef $A, ByRef $B)
	Return $A > $B ? 0 : 1
EndFunc

; MaxIndex von 3 Werten (sollte man inlinen)
Func _3MaxI(ByRef $A, ByRef $B, ByRef $C)
	Return $A > $B ? $A > $C ? 0 : $B > $C ? 1 : 2 : $B > $C ? 1 : 2
EndFunc

; MaxIndex von 4 Werten
Func _4MaxI(ByRef $A, ByRef $B, ByRef $C, ByRef $D)
	Return $A > $B ? $C > $D ? $A > $C ? 0 : 2 : $A > $D ? 0 : 3 : $C > $D ? $B > $C ? 1 : 2 : $B > $D ? 1 : 3
EndFunc

; 2 werte sortieren (sollte man inlinen, das ist zu kurz)
Func _2Sort(ByRef $A, ByRef $B)
	If $A < $B Then Return
	Local $t = $A
	$A = $B
	$B = $t
EndFunc   ;==>_2Sort

; 3 werte sortieren (sollte man inlinen, das ist zu kurz)
Func _3Sort(ByRef $A, ByRef $B, ByRef $C)
	Local $t
	If $A > $B Then
		$t = $A
		$A = $B
		$B = $t
	EndIf
	If $B > $C Then
		$t = $C
		$C = $B
		$B = $t
	EndIf
	If $A > $B Then
		$t = $A
		$A = $B
		$B = $t
	EndIf
EndFunc   ;==>_3Sort

; 4 Werte sortieren
Func _4Sort(ByRef $A, ByRef $B, ByRef $C, ByRef $D)
	Local $t
	If $A > $B Then
		$t = $A
		$A = $B
		$B = $t
	EndIf ; A < B
	If $C > $D Then
		$t = $C
		$C = $D
		$D = $t
	EndIf ; C < D
	If $A > $C Then
		$t = $A
		$A = $C
		$C = $B
		$B = $t ; wir wissen, C < B, daher A <-> C tauschen, danach C und B.
	ElseIf $B > $C Then
		$t = $C
		$C = $B
		$B = $t
	EndIf ; A < alle und B < C
	If $C > $D Then
		$t = $C
		$C = $D
		$D = $t
		If $B > $C Then ; kann nur passieren, wenn vorher C > D war.
			$t = $C
			$C = $B
			$B = $t
		EndIf
	EndIf
EndFunc   ;==>_4Sort

; 5 Werte sortieren
Func _5Sort(ByRef $A, ByRef $B, ByRef $C, ByRef $D, ByRef $E)
	Local $t
	If $A < $B Then ; if a < b:      a, b = b, a
		$t = $B
		$B = $A
		$A = $t
	EndIf
	If $C < $D Then ; if c < d:      c, d = d, c
		$t = $C
		$C = $D
		$D = $t
	EndIf
	If $A < $C Then ; if a < c:      a, b, c, d = c, d, a, b
		$t = $C
		$C = $A
		$A = $t
		$t = $D
		$D = $B
		$B = $t
	EndIf
	If $E < $C Then ;~    if e < c:
		If $E > $D Then ; if e > d:  d, e = e, d
			$t = $D
			$D = $E
			$E = $t
		EndIf
	ElseIf $E < $A Then ; if e < a:  c, d, e = e, c, d
		$t = $C
		$C = $E
		$E = $D
		$D = $t
	Else ;~         else:      a, c, d, e = e, a, c, d
		$t = $A
		$A = $E
		$E = $D
		$D = $C
		$C = $t
	EndIf
	If $B < $D Then ; if b < d:
		If $B < $E Then ; if b < e:  return b, e, d, c, a
			$t = $A
			$A = $B
			$B = $E
			$E = $t
			$t = $C
			$C = $D
			$D = $t
		Else  ; else:      return e, b, d, c, a
			$t = $A
			$A = $E
			$E = $t
			$t = $C
			$C = $D
			$D = $t
		EndIf
	Else
		If $B < $C Then ; if b < c:  return e, d, b, c, a
			$t = $A
			$A = $E
			$E = $t
			$t = $B
			$B = $D
			$D = $C
			$C = $t
		Else  ; else:      return e, d, c, b, a
			$t = $A
			$A = $E
			$E = $t
			$t = $B
			$B = $D
			$D = $t
		EndIf
	EndIf
EndFunc   ;==>_5Sort


; Innerer Teil von __ArrayQuickSort2D für Array der Form [n][2]
;~ Func __A3DQSD(ByRef $a, $s, $e)
;~ 	Local $t, $L = $s, $R = $e, $p = $a[Int(($s + $e) / 2)][0]
;~ 	Do
;~ 		While -($a[$L][0] - $p) < 0
;~ 			$L += 1
;~ 		WEnd
;~ 		While -($a[$R][0] - $p) > 0
;~ 			$R -= 1
;~ 		WEnd
;~ 		If $L <= $R Then
;~ 			$t = $a[$L][0]
;~ 			$a[$L][0] = $a[$R][0]
;~ 			$a[$R][0] = $t
;~ 			$t = $a[$L][1]
;~ 			$a[$L][1] = $a[$R][1]
;~ 			$a[$R][1] = $t
;~ 			$L += 1
;~ 			$R -= 1
;~ 		EndIf
;~ 	Until $L > $R
;~ 	If $R > $s Then __A3DQSD($a, $s, $R)
;~ 	If $e > $L Then __A3DQSD($a, $L, $e)
;~ EndFunc

; Innerer Teil von __ArrayQuickSort2D für Array der Form [n][2] -> TODO -> Wechsel auf Array of Maps
Func __A3DQS(ByRef $a, $s, $e)
	Local $t, $L = $s, $R = $e, $p = $a[Int(($s + $e) / 2)][0]
	Do
		While -($a[$L][0] - $p) < 0
			$L += 1
		WEnd
		While -($a[$R][0] - $p) > 0
			$R -= 1
		WEnd
		If $L <= $R Then
			$t = $a[$L][0]
			$a[$L][0] = $a[$R][0]
			$a[$R][0] = $t
			$t = $a[$L][1]
			$a[$L][1] = $a[$R][1]
			$a[$R][1] = $t
			$L += 1
			$R -= 1
		EndIf
	Until $L > $R
	If $R > $s Then __A3DQS($a, $s, $R)
	If $e > $L Then __A3DQS($a, $L, $e)
EndFunc

; Innerer Teil von __ArrayQuickSort2D für Array der Form [n][2]
; zusätzlich wird früh abgebrochen. Die Sortierung ist also
; nur "fast" richtig was bei vielen Modellen nicht so schlimm ist.
; Bei Kugeln muss man z.B. gar nicht sortieren.
Func __A3DQS2(ByRef $a, $s, $e)
	Local $t, $L = $s, $R = $e, $p = $a[Int(($s + $e) / 2)][0]
	Do
		While -($a[$L][0] - $p) < 0
			$L += 1
		WEnd
		While -($a[$R][0] - $p) > 0
			$R -= 1
		WEnd
		If $L <= $R Then
			$t = $a[$L][0]
			$a[$L][0] = $a[$R][0]
			$a[$R][0] = $t
			$t = $a[$L][1]
			$a[$L][1] = $a[$R][1]
			$a[$R][1] = $t
			$L += 1
			$R -= 1
		EndIf
	Until $L > $R
	If $R > $s And $R - $s > 5 Then __A3DQS2($a, $s, $R)
	If $e > $L And $e - $L > 5 Then __A3DQS2($a, $L, $e)
EndFunc