
; Das ist nur ein Test :)
; v3

; TODO:
; Sparse Trafos benutzen wenn möglich (man muss ja nicht immer die volle 44x44 multiplikation machen, manchmal reichen auch 3 Werte)
; near & far Plane anschauen, die machen nicht was sie sollen glaub ich.
; Geometry: refactoring
; Geometry: Funktionen in neues Format überführen (z.B. subdiv)
; Light: TODO (statische Beleuchtung via Geometry + Lichtquellen)
; Matrix.au3, Vec3f.au3 in Linalg.au3 integrieren

#include '_A3D_Core.au3'
#include 'Include/Buffer.au3'
#include <Misc.au3>

Opt('GuiOnEventMode', 1)

Global $bExit = False
Func Xit()
	$bExit = True
EndFunc

If @ScriptName = 'Test.au3' Then
	Global $graphics = 0
	A3D_Example2()
EndIf

Func SunColors(ByRef $aGeo)
	_SunColors($aGeo[2])
EndFunc
Func _SunColors(ByRef $aColors)
	For $i = 0 To UBound($aColors) - 1 Step 1
		$aColors[$i] = Int('0xFF' & Hex(Round(Random(220, 255, 1)), 2) & Hex(Round(Random(150, 175, 1)), 2) & '00')
	Next
EndFunc

Func PlanetColors(ByRef $aGeo, $n)
	_PlanetColors($aGeo[2], $n)
EndFunc
Func _PlanetColors(ByRef $aColors, $n)
	For $i = 0 To UBound($aColors) - 1 Step 1
		Local $R = Round(Int('0x' & StringMid(Hex($aColors[$i], 8), 3, 2)) + Random(-10, 10, 1))
		Local $G = Round(Int('0x' & StringMid(Hex($aColors[$i], 8), 5, 2)) + Random(-10, 10, 1))
		Local $B = Round(Int('0x' & StringMid(Hex($aColors[$i], 8), 7, 2)) + Random(-10, 10, 1))
		If $R < 0 Then $R = 0
		If $R > 255 Then $R = 255
		If $G < 0 Then $G = 0
		If $G > 255 Then $G = 255
		If $B < 0 Then $B = 0
		If $B > 255 Then $B = 255

		$aColors[$i] = Int('0xFF' & Hex($R,2) & Hex($G,2) & Hex($B,2))
	Next
EndFunc

Func Sun()
	Local $aSun[]
	$aSun[0] = _A3D_Polyhedron($A3G_ICOSAHEDRON, 3, 0xFFFF9400)
	$aSun[1] = _A3D_Polyhedron($A3G_ICOSAHEDRON, 3, 0x28FFE000)
	$aSun[2] = _A3D_Polyhedron($A3G_ICOSAHEDRON, 3, 0x28FFE000)
;~ 	_A3G_Subdiv($aSun[0])
;~ 	_A3G_ProjectOnSphere($aSun[0])
	For $i = 0 To 0 Step 1
		_A3G_Subdiv($aSun[0])
		_A3G_ProjectOnSphere($aSun[0])
		_A3G_Subdiv($aSun[1])
		_A3G_ProjectOnSphere($aSun[1])
		_A3G_Subdiv($aSun[2])
		_A3G_ProjectOnSphere($aSun[2])
	Next

	SunColors($aSun[0])

;~ 	_A3G_Scale($aSun[0], 1.25)
	_A3G_Scale($aSun[1], 1.45)
	_A3G_Scale($aSun[2], 1.60)
	$aSun.Layers = 3
	$aSun.Radius = 0
	$aSun.Pos = 0
	$aSun.Rotation = 0
	$aSun.RotationSpeed = 1
	Return $aSun
EndFunc

Func Planet($n = 0)
	Local $aPlanet[]
	$aPlanet.Radius = Random(2, 15)
	$aPlanet.Pos = Random(0, 7)
	$aPlanet.Rotation = 0
	$aPlanet.RotationSpeed = Random(5, 15) * (Random(0, 1) < 0.5 ? -1 : 1)
	$aPlanet.Layers = 1
	Local $nScale = Random(0.05, 0.35) * $aPlanet.Radius ^ 0.25 + $aPlanet.Radius / 100

	Local $Red = Hex(Round(200 - $aPlanet.Radius * 10), 2)
	Local $Green = Hex(Round(70 + $aPlanet.Radius * 7), 2)
	Local $Blue = Hex(Round(0 + $aPlanet.Radius * 22), 2)
	Local $Color = Int('0xFF' & $Red & $Green & $Blue)

	ConsoleWrite($nScale & @CRLF)

	Switch $nScale
		Case 0 To 0.15
			$aPlanet[0] = _A3D_Polyhedron($A3G_TETRAHEDRON, 3, $Color)
		Case 0.15 To 0.25
			$aPlanet[0] = _A3D_Polyhedron($A3G_HEXAHEDRON, 4, $Color)
		Case 0.25 To 0.35
			$aPlanet[0] = _A3D_Polyhedron($A3G_OCTAHEDRON, 3, $Color)
		Case Else
			Switch Random(0, 1, 1)
				Case 0
					$aPlanet[0] = _A3D_Polyhedron($A3G_DODECAHEDRON, 5, $Color)
				Case 1
					$aPlanet[0] = _A3D_Polyhedron($A3G_ICOSAHEDRON, 3, $Color)
			EndSwitch
	EndSwitch

	PlanetColors($aPlanet[0], $n)
	_A3G_Scale($aPlanet[0], $nScale)
	Return $aPlanet
EndFunc

Func DrawBody(ByRef $a, $dt)
	Local $aPos = [$a.Radius * Cos($a.Pos), 0, $a.Radius * Sin($a.Pos)]
	Local $aRotation = [0, $a.Rotation, 0]
	If $a.Radius Then $a.Pos += $dt * 1.5 / $a.Radius^0.75
	$a.Rotation += $a.RotationSpeed * $dt * 0.1
	_A3D_Push()
	_A3D_TranslateV($aPos)
	_A3D_RotateV($aRotation)
	For $i = 0 To $a.Layers - 1 Step 1
		_A3D_GeometryDraw($a[$i])
	Next
	_A3D_Pop()
EndFunc


Func A3D_Example2()

	_A3D_Startup(1024)

	Local $Sun = Sun(), $Planets[30]
	For $i = 0 To UBound($Planets) - 1 Step 1
		$Planets[$i] = Planet($i)
	Next

	_GDIPlus_Startup()
	Local $hGUI = GUICreate('', $A3D_WIDTH, $A3D_HEIGHT)
	Local $hDC = _WinAPI_GetDC($hGUI)
	Local $hBUF = BufferCreate($A3D_WIDTH, $A3D_HEIGHT)
	Local $hGFX = _GDIPlus_GraphicsCreateFromHDC($hBUF.hDC)
;~ 	_GDIPlus_GraphicsSetSmoothingMode($hGFX, 2)
	GUISetState()

	GUISetOnEvent(-3, Xit)

	Local $iGlobalTimer = TimerInit(), $iGlobalTime, $dt = 0
	Local $iFpsTimer = TimerInit()
	Local $iFPS = 0

	_A3D_CameraPosition(1, 2, 3.5)


	Local $aPos = MouseGetPos()
	Local Static $aLastPos = $aPos

	While Not $bExit

		_GDIPlus_GraphicsClear($hGFX)
		$dt = $iGlobalTime
		$iGlobalTime = TimerDiff($iGlobalTimer)
		$dt = ($iGlobalTime - $dt) / 1000

		_A3D_BeginScene()

		DrawBody($Sun, $dt)

		For $i = 0 To UBound($Planets) - 1 Step 1
			DrawBody($Planets[$i], $dt)
		Next
		$aLastPos = $aPos
		$aPos = MouseGetPos()
		If _IsPressed('01') Then
			$A3D_CA[0] += -($aPos[1] - $aLastPos[1])/500
			$A3D_CA[1] += ($aPos[0] - $aLastPos[0])/500
		EndIf
		If _IsPressed('02') Then
			$A3D_CA[2] += -($aPos[0] - $aLastPos[0])/500
		EndIf

		_A3D_EndScene($hGFX)

		DllCall($GDI32DLL, 'bool', 'BitBlt', 'handle', $hDC, 'int', 0, 'int', 0, 'int', $A3D_WIDTH, 'int', $A3D_HEIGHT, 'handle', $hBUF.hDC, 'int', 0, 'int', 0, 'dword', 0x00CC0020)

		$iFPS += 1
		If TimerDiff($iFpsTimer) > 1000 Then
			WinSetTitle($hGUI, '', 'Test@' & $iFPS & ' (FrameBuffer -> Vtx: ' & $A3D_VC & ' Elements: ' & $A3D_IC & ')')
			$iFPS = 0
			$iFpsTimer = TimerInit()
		EndIf

	WEnd

	_GDIPlus_GraphicsDispose($hGFX)
	_WinAPI_ReleaseDC($hGUI, $hDC)
	BufferDelete($hBUF)
	_GDIPlus_Shutdown()

	_A3D_Shutdown()

EndFunc
