
#include-once
#include '_A3D_Header.au3'
#include 'Include\Matrix.au3'

; Teil von A3D
; Behandelt Kameratransformationen etc.

Global $A3D_MSVCRT = 0
Func __A3D_CameraStartup()
	$A3D_MSVCRT = DllOpen('msvcrt.dll')
EndFunc
Func __A3D_CameraShutdown()
	DllClose($A3D_MSVCRT)
EndFunc

Global $A3D_CA[4] ; [0, 1, 2] = Winkel, [3] = Abstand zur Mitte
Global $A3D_CP[3] ; Camera position in World-Coordinates
Global $A3D_CN[3] = [0, 0, -1] ; CameraNormal (das ist ein unveränderlicher Wert, Bewege das Modell und nicht die Kamera)
Global $A3D_CM = $A3D_MATI


Func __A3D_UpdateCamera()

	; Das kann man optimieren für die FPS!

	Local $x = $A3D_CA[0], $y = $A3D_CA[1], $z = $A3D_CA[2]
	Local $_ = [ _
	[Cos($y) * Cos($z), -Cos($y) * Sin($z), Sin($y)], _
	[Sin($x) * Sin($y) * Cos($z) + Cos($x) * Sin($z), -Sin($x) * Sin($y) * Sin($z) + Cos($x) * Cos($z), -Sin($x) * Cos($y)], _
	[-Sin($y) * Cos($x) * Cos($z) + Sin($x) * Sin($z), Sin($y) * Cos($x) * Sin($z) + Sin($x) * Cos($z), Cos($x) * Cos($y)]]



	Local $yAxis = [0, 1, 0], $v = M33MulXYZV($_, $yAxis)

	Local $t = [ _
	[1, 0, 0, 0], _
	[0, 1, 0, 0], _
	[0, 0, 1, $A3D_CA[3]], _
	[0, 0, 0, 1]]

	$A3D_CM = M44MulM33($t, $_)



	Local $x = $A3D_CA[0], $y = $A3D_CA[1], $z = $A3D_CA[2]
	Local $_33 = [ _
	[Cos($y) * Cos($z), -Cos($y) * Sin($z), Sin($y)], _
	[Sin($x) * Sin($y) * Cos($z) + Cos($x) * Sin($z), -Sin($x) * Sin($y) * Sin($z) + Cos($x) * Cos($z), -Sin($x) * Cos($y)], _
	[-Sin($y) * Cos($x) * Cos($z) + Sin($x) * Sin($z), Sin($y) * Cos($x) * Sin($z) + Sin($x) * Cos($z), Cos($x) * Cos($y)]]
	$_33 = M33Inv($_33) ; optimize this -> inverse direkt hinschreiben.

	Local $aCamPos = [0, 0, -$A3D_CA[3]]
	$A3D_CP = M33MulXYZV($_33, $aCamPos)

;~ 	Local $s = 'Pos: ' & StringFormat('%.1f', $A3D_CP[0]) & ' ' & StringFormat('%.1f', $A3D_CP[1]) & ' ' & StringFormat('%.1f', $A3D_CP[2]) & _
;~ 	' (Len: ' & StringFormat('%.1f', Sqrt($A3D_CP[0]^2+$A3D_CP[1]^2+$A3D_CP[2]^2)) & ')' & @CRLF & 'Angles: ' & _
;~ 	StringFormat('%.0f', $A3D_CA[0] * $A3D_RADTODEG) & ' ' & StringFormat('%.0f', $A3D_CA[1] * $A3D_RADTODEG) & ' ' & StringFormat('%.0f',$A3D_CA[2] * $A3D_RADTODEG)
;~ 	ConsoleWrite('Cam: ' & $s & @CRLF)
;~ 	Sleep(10)


EndFunc


; Set camera distance from center
Func _A3D_CameraDistance($nDist)
	$A3D_CA[3] = $nDist
EndFunc
; Change the distance of the camera to the center.
; $nDistMul - Multiplicative Value (multiplies current distance. can be anything)
; $nDistAdd - Additive Value (adds to the current camera distance)
Func _A3D_CameraZoom($nDistMul = 1.0, $nDistAdd = 0.0)
	$A3D_CA[3] = $A3D_CA[3] * $nDistMul + $nDistAdd
EndFunc

; Set camera position on a sphere with angles
Func _A3D_CameraAngle($nDegX, $nDegY, $nDegZ)
	$A3D_CA[0] = $nDegX * $A3D_DEGTORAD
	$A3D_CA[1] = $nDegY * $A3D_DEGTORAD
	$A3D_CA[2] = $nDegZ * $A3D_DEGTORAD
EndFunc
Func _A3D_CameraAngleV($aAngle)
	$A3D_CA[0] = $aAngle[0] * $A3D_DEGTORAD
	$A3D_CA[1] = $aAngle[1] * $A3D_DEGTORAD
	$A3D_CA[2] = $aAngle[2] * $A3D_DEGTORAD
EndFunc

; Rotate the camera around x, y, z
Func _A3D_CameraRotate($nDegX = 0, $nDegY = 0, $nDegZ = 0)
	$A3D_CA[0] += $nDegX * $A3D_DEGTORAD
	$A3D_CA[1] += $nDegY * $A3D_DEGTORAD
	$A3D_CA[2] += $nDegZ * $A3D_DEGTORAD
EndFunc
Func _A3D_CameraRotateV($aAngle)
	$A3D_CA[0] += $aAngle[0] * $A3D_DEGTORAD
	$A3D_CA[1] += $aAngle[1] * $A3D_DEGTORAD
	$A3D_CA[2] += $aAngle[2] * $A3D_DEGTORAD
EndFunc

; Set camera position in cartesian coordinates
Func _A3D_CameraPosition($x, $y, $z)
	$A3D_CA[3] = ($x^2 + $y^2 + $z^2)^0.5
	$A3D_CA[0] = ASin(-$y/$A3D_CA[3])
	$A3D_CA[1] = DllCall($A3D_MSVCRT, 'double:cdecl', 'atan2', 'double', $x, 'double', -$z)[0]
	$A3D_CA[2] = 0
EndFunc
Func _A3D_CameraPositionV($aPos)
	$A3D_CA[3] = ($aPos[0]^2 + $aPos[1]^2 + $aPos[2]^2)^0.5
	$A3D_CA[0] = ASin(-$aPos[1]/$A3D_CA[3])
	$A3D_CA[1] = DllCall($A3D_MSVCRT, 'double:cdecl', 'atan2', 'double', $aPos[0], 'double', -$aPos[2])[0]
	$A3D_CA[2] = 0
EndFunc

