#include-once

; A3D Header
; Die Variablennamen der Arrays sind absichtlich abgekürzt (z.B. A3D_VA) zu Optimierungszwecken.
; Jedes Zeichen in einem Variablennamen braucht Zeit im Interpreter, selbst wenn es sehr wenig ist
; summiert sich das. von 50 auf 51 FPS durch kurze Namen -> yeeeeah :D

; Engine Settings
Global $A3D_POLYGON_LIMIT     = 5000 ; Maximum number of allowed polygons
Global $A3D_POLYVERTEX_LIMIT  = 5    ; Maximum allowed points per polygon, currently 4 is the maximum, may be higher someday.
Global $A3D_MATRIXSTACK_LIMIT = 16   ; Maximum Stacksize for MatrixPush and MatrixPop
Global $A3D_VERTEXARRAY_LIMIT = $A3D_POLYGON_LIMIT * $A3D_POLYVERTEX_LIMIT ; Maximum allowed Vertices

; Constants
Global Const $A3D_DEGTORAD = ATan(1) / 45
Global Const $A3D_RADTODEG = 45 / ATan(1)
Global Const $A3D_EPSILON  = 1e-6 ; Vertices die näher zusammen liegen als das werden als "ein Vertex" interpretiert.
Global Const $A3D_MATI = [[1, 0, 0, 0], [0, 1, 0, 0], [0, 0, 1, 0], [0, 0, 0, 1]]

; Viewport
Global $A3D_WIDTH, $A3D_HEIGHT, $A3D_ASPECT, $A3D_FOV, $A3D_FOVRAD, $A3D_CLIPNEAR, $A3D_CLIPFAR, $A3D_CLIP, $A3D_CLIPRANGE
Global $A3D_PM = $A3D_MATI, $A3D_DM = $A3D_MATI, $A3D_FM = $A3D_MATI
Func __A3D_UpdateViewport($iWidth = 600, $iHeight = 450, $nFovDeg = 70, $nClipNear = 0.1, $nClipFar = 100)
	$A3D_WIDTH = Int($iWidth)
	$A3D_HEIGHT = Int($iHeight)
	$A3D_ASPECT = $A3D_WIDTH / $A3D_HEIGHT
	$A3D_FOV = $A3D_DEGTORAD * $nFovDeg
	$A3D_FOVRAD = 1 / Tan($A3D_FOV / 2) ; Factor
	$A3D_CLIPNEAR = $nClipNear
	$A3D_CLIPFAR = $nClipFar
	$A3D_CLIP = $A3D_CLIPNEAR / ($A3D_CLIPFAR - $A3D_CLIPNEAR)
	$A3D_CLIPRANGE = $A3D_CLIPFAR - $A3D_CLIPNEAR ; Global used to be able to assign the whole array at once
	Global $A3D_PM = [ _
		[$A3D_FOVRAD / $A3D_ASPECT, 0          , 0                                              , 0                                                  ], _
		[0                        , $A3D_FOVRAD, 0                                              , 0                                                  ], _
		[0                        , 0          , -($A3D_CLIPFAR + $A3D_CLIPNEAR) / $A3D_CLIPRANGE, -(2 * $A3D_CLIPFAR * $A3D_CLIPNEAR) / $A3D_CLIPRANGE], _
		[0                        , 0          , -1                                             , 0                                                  ]]

;~ 	Global $A3D_PM = [ _
;~ 		[$A3D_FOVRAD / $A3D_ASPECT, 0          , 0                                              , 0                                                  ], _
;~ 		[0                        , $A3D_FOVRAD, 0                                              , 0                                                  ], _
;~ 		[0                        , 0          , -$A3D_CLIPFAR / $A3D_CLIPRANGE                 , -($A3D_CLIPFAR * $A3D_CLIPNEAR) / $A3D_CLIPRANGE], _
;~ 		[0                        , 0          , -1                                             , 0                                                  ]]



EndFunc
__A3D_UpdateViewport()

; Vertices (vertex array)
;~ Global $A3D_DVA[$A3D_VERTEXARRAY_LIMIT][3] ; [0] = x, [1] = y, [2] = z
Global $A3D_VA[$A3D_VERTEXARRAY_LIMIT] ; [0] = Array3(x,y,z)
Global $A3D_VC = 0

; unsorted-Buffer (index array)
Global $A3D_IA[$A3D_POLYGON_LIMIT][2] ; Object Array, [i][0] = [numVertices, vtx1, ..., vtxN], [i][1] = Color32
Global $A3D_IC = 0

; z-Permutation (in Bezug zu index array)
Global $A3D_ZA[$A3D_POLYGON_LIMIT][2] ; use this permutation on the unsorted buffer to get a sorted buffer duh!
; [0] = index in unsorted buffer
; [1] = central z-value for object